HDU 2473 Junk-Mail Filter (并查集的删除操作)

Problem Description
Recognizing junk mails is a tough task. The method used here consists of two steps:
1) Extract the common characteristics from the incoming email.
2) Use a filter matching the set of common characteristics extracted to determine whether the email is a spam.

We want to extract the set of common characteristics from the N sample junk emails available at the moment, and thus having a handy data-analyzing tool would be helpful. The tool should support the following kinds of operations:

a) “M X Y”, meaning that we think that the characteristics of spam X and Y are the same. Note that the relationship defined here is transitive, so
relationships (other than the one between X and Y) need to be created if they are not present at the moment.

b) “S X”, meaning that we think spam X had been misidentified. Your tool should remove all relationships that spam X has when this command is received; after that, spam X will become an isolated node in the relationship graph.

Initially no relationships exist between any pair of the junk emails, so the number of distinct characteristics at that time is N.
Please help us keep track of any necessary information to solve our problem.
 

Input
There are multiple test cases in the input file.
Each test case starts with two integers, N and M (1 ≤ N ≤ 105 , 1 ≤ M ≤ 106), the number of email samples and the number of operations. M lines follow, each line is one of the two formats described above.
Two successive test cases are separated by a blank line. A case with N = 0 and M = 0 indicates the end of the input file, and should not be processed by your program.
 

Output
For each test case, please print a single integer, the number of distinct common characteristics, to the console. Follow the format as indicated in the sample below.
 

Sample Input
5 6 M 0 1 M 1 2 M 1 3 S 1 M 1 2 S 3 3 1 M 1 2 0 0
 

Sample Output
Case #1: 3

Case #2: 2

题意:S是将该点从集合中剥离出来,M是联合起来。求出最后的联通块

思路:就是并查集的删除操作了!多开一个数组来记录当前点的映射位置!由于眼下还没有其它的算法能将并查集的节点分离出来而不影响其结构。所以分离出来的点的映射位置应为之前没出现的点,合并操作的时候也是要这样操作映射数组!

所以AC代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<set>
using namespace std;

const int maxn=100000+10;
int f[maxn*10],a[maxn];

int find(int x)
{
    if(x!=f[x])
        f[x]=find(f[x]);
    return f[x];
}

void Union(int x,int y)
{
    x=find(x);
    y=find(y);
    if(x==y)return ;
    f[x]=y;
}

set<int>s;

int main()
{
    #ifndef ONLINE_JUDGE
    freopen("in.cpp","r",stdin);
    freopen("out.cpp","w",stdout);
    #endif // ONLINE_JUDGE
    int n,m;
    char str[2];
    int cas=1;
    while(scanf("%d %d",&n,&m)==2&&(n+m))
    {
        s.clear();
        for(int i=0;i<=n;i++)
        {
            f[i]=i;
            a[i]=i;
        }
        int num=n;
        while(m--)
        {
            scanf("%s",str);
            if(str[0]=='S')
            {
                int k;
                scanf("%d",&k);
                a[k]=num++;
                f[a[k]]=a[k];
            }
            else
            {
                int x,y;
                scanf("%d %d",&x,&y);
                Union(a[x],a[y]);
            }
        }

        for(int i=0;i<n;i++)
        {
            s.insert(find(a[i]));
        }
        printf("Case #%d: %d
",cas++,s.size());
    }
    return 0;
}


原文地址:https://www.cnblogs.com/llguanli/p/7071624.html